Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# GPS::GeneralParticleSystem< Particle > Class Template Reference

`#include <GeneralParticleSystem.h>`

List of all members.

## Public Types
typedef std::vector< Particle > | VOP
typedef std::vector< VOP > | VOVOP
typedef std::vector< VOVOP > | VOVOVOP
## Public Member Functions
| GeneralParticleSystem ()
| Default constructor.
virtual | ~GeneralParticleSystem ()
| Default destructor.
int | getMaxX ()
| Return maximal X Value of the particles.
int | getMaxY ()
| Return maximal Y Value of the particles.
int | getMinX ()
| Return minimal X Value of the particles.
int | getMinY ()
| Return minimal X Value of the particles.
void | addParticle (Particle p)
| Add a Particle to the ParticleStore.
Particle & | getParticle (int i)
| Get a Particle from the ParticleStore.
Particle & | getParticleByID (unsigned long id)
| Get a particle with a specified ID.
void | removeParticle (int i)
| Remove a particle from the ParticleStore.
int | getNumOfParticles ()
| Return the number of particles in the ParticleStore.
Particle & | operator[] (int i)
| Return the particle in the store by the [] Operator.
std::vector< std::vector< Particle > > | getCluster (unsigned int numberOfClusterToFind=4, int densityX=20, int densityY=20)
| Return the clusterPoints of the Particles in the System.
## Private Types
typedef std::list< bestCellt > | LISTSTR
## Private Member Functions
void | findMinMaxValuesInParticleStore ()
| Find the min / max values of the coordinates in the particle System.
## Static Private Member Functions
bool | DFBestCellGreater (bestCellt b, bestCellt a)
## Private Attributes
std::vector< Particle > | particleStore
int | minX
int | minY
int | maxX
int | maxY

### template<class Particle>
class GPS::GeneralParticleSystem< Particle >

## Member Typedef Documentation

template<class Particle>
typedef std::list<bestCellt> GPS::GeneralParticleSystem< Particle >::LISTSTR`[private]`

| Definition at line 49 of file GeneralParticleSystem.h.

template<class Particle>
typedef std::vector<Particle> GPS::GeneralParticleSystem< Particle >::VOP

| Definition at line 70 of file GeneralParticleSystem.h.

template<class Particle>
typedef std::vector<VOP> GPS::GeneralParticleSystem< Particle >::VOVOP

| Definition at line 71 of file GeneralParticleSystem.h.

template<class Particle>
typedef std::vector<VOVOP> GPS::GeneralParticleSystem< Particle >::VOVOVOP

| Definition at line 72 of file GeneralParticleSystem.h. Referenced by GPS::GeneralParticleSystem< Particle >::getCluster().

## Constructor & Destructor Documentation

template<class Particle>
GPS::GeneralParticleSystem< Particle >::GeneralParticleSystem | ( |  | ) | `[inline]`

| Default constructor. Definition at line 78 of file GeneralParticleSystem.h. References GPS::GeneralParticleSystem< Particle >::maxY, and GPS::GeneralParticleSystem< Particle >::minY.

template<class Particle>
virtual GPS::GeneralParticleSystem< Particle >::~GeneralParticleSystem | ( |  | ) | `[inline, virtual]`

| Default destructor. Definition at line 88 of file GeneralParticleSystem.h.

## Member Function Documentation

template<class Particle>
bool GPS::GeneralParticleSystem< Particle >::DFBestCellGreater | ( | bestCellt | b,
|  | bestCellt | a
| ) | `[inline, static, private]`

| Definition at line 45 of file GeneralParticleSystem.h. References GPS::GeneralParticleSystem< Particle >::bestCellt::count.

template<class Particle>
void GPS::GeneralParticleSystem< Particle >::findMinMaxValuesInParticleStore | ( |  | ) | `[inline, private]`

| Find the min / max values of the coordinates in the particle System. Definition at line 54 of file GeneralParticleSystem.h. References GPS::GeneralParticleSystem< Particle >::maxY, GPS::GeneralParticleSystem< Particle >::minY, and GPS::GeneralParticleSystem< Particle >::particleStore. Referenced by GPS::GeneralParticleSystem< Particle >::removeParticle().

template<class Particle>
int GPS::GeneralParticleSystem< Particle >::getMaxX | ( |  | ) | `[inline]`

| Return maximal X Value of the particles. Definition at line 95 of file GeneralParticleSystem.h.

template<class Particle>
int GPS::GeneralParticleSystem< Particle >::getMaxY | ( |  | ) | `[inline]`

| Return maximal Y Value of the particles. Definition at line 102 of file GeneralParticleSystem.h. References GPS::GeneralParticleSystem< Particle >::maxY.

template<class Particle>
int GPS::GeneralParticleSystem< Particle >::getMinX | ( |  | ) | `[inline]`

| Return minimal X Value of the particles. Definition at line 109 of file GeneralParticleSystem.h.

template<class Particle>
int GPS::GeneralParticleSystem< Particle >::getMinY | ( |  | ) | `[inline]`

| Return minimal X Value of the particles. Definition at line 116 of file GeneralParticleSystem.h. References GPS::GeneralParticleSystem< Particle >::minY.

template<class Particle>
void GPS::GeneralParticleSystem< Particle >::addParticle | ( | Particle | p | ) | `[inline]`

| Add a Particle to the ParticleStore. Definition at line 123 of file GeneralParticleSystem.h. References GPS::GeneralParticleSystem< Particle >::maxY, GPS::GeneralParticleSystem< Particle >::minY, and GPS::GeneralParticleSystem< Particle >::particleStore.

template<class Particle>
Particle& GPS::GeneralParticleSystem< Particle >::getParticle | ( | int | i | ) | `[inline]`

| Get a Particle from the ParticleStore. Definition at line 138 of file GeneralParticleSystem.h. References GPS::GeneralParticleSystem< Particle >::particleStore. Referenced by GPS::GeneralParticleSystem< Particle >::getCluster(), and GPS::GeneralParticleSystem< Particle >::operator[]().

template<class Particle>
Particle& GPS::GeneralParticleSystem< Particle >::getParticleByID | ( | unsigned long | id | ) | `[inline]`

| Get a particle with a specified ID. Definition at line 145 of file GeneralParticleSystem.h. References GPS::GeneralParticleSystem< Particle >::particleStore.

template<class Particle>
void GPS::GeneralParticleSystem< Particle >::removeParticle | ( | int | i | ) | `[inline]`

| Remove a particle from the ParticleStore. Definition at line 157 of file GeneralParticleSystem.h. References GPS::GeneralParticleSystem< Particle >::findMinMaxValuesInParticleStore(), and GPS::GeneralParticleSystem< Particle >::particleStore.

Here is the call graph for this function:

template<class Particle>
int GPS::GeneralParticleSystem< Particle >::getNumOfParticles | ( |  | ) | `[inline]`

| Return the number of particles in the ParticleStore. Definition at line 168 of file GeneralParticleSystem.h. References GPS::GeneralParticleSystem< Particle >::particleStore. Referenced by GPS::GeneralParticleSystem< Particle >::getCluster().

template<class Particle>
Particle& GPS::GeneralParticleSystem< Particle >::operator[] | ( | int | i | ) | `[inline]`

| Return the particle in the store by the [] Operator. Definition at line 175 of file GeneralParticleSystem.h. References GPS::GeneralParticleSystem< Particle >::getParticle().

Here is the call graph for this function:

template<class Particle>
std::vector< std::vector<Particle> > GPS::GeneralParticleSystem< Particle >::getCluster | ( | unsigned int | numberOfClusterToFind = 4,
|  | int | densityX = 20,
|  | int | densityY = 20
| ) | `[inline]`

| Return the clusterPoints of the Particles in the System. Definition at line 183 of file GeneralParticleSystem.h. References GPS::GeneralParticleSystem< Particle >::bestCellt::count, GPS::GeneralParticleSystem< Particle >::getNumOfParticles(), GPS::GeneralParticleSystem< Particle >::getParticle(), LINE, GPS::GeneralParticleSystem< Particle >::maxY, GPS::GeneralParticleSystem< Particle >::minY, GPS::GeneralParticleSystem< Particle >::particleStore, GPS::GeneralParticleSystem< Particle >::VOVOVOP, GPS::GeneralParticleSystem< Particle >::bestCellt::x, and GPS::GeneralParticleSystem< Particle >::bestCellt::y.

Here is the call graph for this function:

## Member Data Documentation

template<class Particle>
std::vector<Particle> GPS::GeneralParticleSystem< Particle >::particleStore`[private]`

| Definition at line 35 of file GeneralParticleSystem.h. Referenced by GPS::GeneralParticleSystem< Particle >::addParticle(), GPS::GeneralParticleSystem< Particle >::findMinMaxValuesInParticleStore(), GPS::GeneralParticleSystem< Particle >::getCluster(), GPS::GeneralParticleSystem< Particle >::getNumOfParticles(), GPS::GeneralParticleSystem< Particle >::getParticle(), GPS::GeneralParticleSystem< Particle >::getParticleByID(), and GPS::GeneralParticleSystem< Particle >::removeParticle().

template<class Particle>
int GPS::GeneralParticleSystem< Particle >::minX`[private]`

| Definition at line 36 of file GeneralParticleSystem.h.

template<class Particle>
int GPS::GeneralParticleSystem< Particle >::minY`[private]`

| Definition at line 36 of file GeneralParticleSystem.h. Referenced by GPS::GeneralParticleSystem< Particle >::addParticle(), GPS::GeneralParticleSystem< Particle >::findMinMaxValuesInParticleStore(), GPS::GeneralParticleSystem< Particle >::GeneralParticleSystem(), GPS::GeneralParticleSystem< Particle >::getCluster(), and GPS::GeneralParticleSystem< Particle >::getMinY().

template<class Particle>
int GPS::GeneralParticleSystem< Particle >::maxX`[private]`

| Definition at line 36 of file GeneralParticleSystem.h.

template<class Particle>
int GPS::GeneralParticleSystem< Particle >::maxY`[private]`

| Definition at line 36 of file GeneralParticleSystem.h. Referenced by GPS::GeneralParticleSystem< Particle >::addParticle(), GPS::GeneralParticleSystem< Particle >::findMinMaxValuesInParticleStore(), GPS::GeneralParticleSystem< Particle >::GeneralParticleSystem(), GPS::GeneralParticleSystem< Particle >::getCluster(), and GPS::GeneralParticleSystem< Particle >::getMaxY().

The documentation for this class was generated from the following file:

- Tools/GeneralParticleSystem/GeneralParticleSystem.h